//add the servo library
#include <Servo.h>

//define our servos
Servo servorx;
Servo servory;
Servo servolx;
Servo servoly;
Servo servoup;
Servo servodown;

//define all component pins
int joyX = A5;
int joyY = A4;
int joypush = 4;
int button = 3;
int ledl = 7;
int ledr = 8;
int rx = A0;
int lx = A2;
int ry = A1;
int ly = A3;
int up = 6;
int down = 5;
  
//variables to read the values from the analog pins 
int VallX = 0;
int ValrX = 0;
int ValrY = 0;
int VallY = 0;

//variable to track the state of the leds
bool light = false;

void setup() {
  //attaches the servos we have defined on their pins
  servorx.attach(rx);
  servory.attach(ry);
  servolx.attach(lx);
  servoly.attach(ly);
  servoup.attach(up);
  servodown.attach(down);
  
  //sets led's pins as outputs 
  pinMode (ledl, OUTPUT);
  pinMode (ledr, OUTPUT);
  
  //sets button and potentiometer pins as inputs
  pinMode (joypush, INPUT_PULLUP);
  pinMode (button, INPUT);
  pinMode (joyX, INPUT);
  pinMode (joyY, INPUT);
}

void loop() { 
  //read the value of joystick (between 0-1023)and map it according the right and left x servos range of motion
  VallX = map(analogRead(joyX),0,1023,0,160);
  ValrX = map(analogRead(joyX),0,1023,60,125);
  
  //move both x servos to match the angle mapped from the joystick position
  servorx.write(ValrX);
  servolx.write(VallX); 
  
  //read the value of joystick (between 0-1023)and map it according the right and left y servos range of motion
  ValrY = map(analogRead(joyY),0,1023,50,100);
  VallY = map(analogRead(joyY),0,1023,120,50);
  
  //move both y servos to match the angle mapped from the joystick position
  servory.write(ValrY);
  servoly.write(VallY);
  
  //check if the joystick button is pressed, if thus, execute the function blink
  if (digitalRead (joypush) == LOW) 
  {
   Blink ();
  }
  
  //check wether the button is pressed, if thus, execute the function light change
  if (digitalRead (button) == HIGH) 
  {
   LightChange ();
  }
  
}

  //declare the function blink
int Blink () 
{
  //move the eyelid servos to close them
  servoup.write(115);
  servodown.write(95);
  
  //wait 300 miliseconds
  delay (300);
  
  //move the eyelid servos to open them
  servoup.write(85);
  servodown.write(80);
}

  //declare the function light change
int LightChange () 
{
  //check if the lights are on
 if (light)
 {
   
  //if they are, turn them off and update the light tracking value
   digitalWrite (ledl, LOW);
   digitalWrite (ledr, LOW);
   light = false;
 } else
 {
   
  //if they are not on, turn them on and update the light tracking value
   digitalWrite (ledl, HIGH);
   digitalWrite (ledr, HIGH);
   light = true;
 }
  //wait for half a second to prevent recieving mora than 1 input in this window of time
  delay (500);
}
